<template>
	<div class="card" v-if="state === AccountState.Password">
		<span>Password reset</span>
		<p>Use this form to change your game account password.</p>
		<form class="login" @submit.prevent="pwReset">
			<br>
			<label for="password">password: </label>
			<input v-focus required name="password" id="password" ref="password" v-model="user.password" type="password" placeholder="new password" minlength="8" maxlength="30" pattern="^[^\s][^\t\r\n]{6,28}[^\s]$" title="8-30 characters" />
			<br><br>
			<button type="submit" ref="reset" class="button prime">Confirm</button> &nbsp;
			<button type="button" @click="state = AccountState.Init" class="button ghost">Cancel</button>
		</form>
	</div>
	<div class="card" v-else-if="state === AccountState.Username">
		<span>Name change</span>
		<p>Use this form to change your game account username.</p>
		<form class="login" @submit.prevent="nameChange">
			<br>
			<label for="username">username: </label>
			<input v-focus class="input" required name="username" id="username" ref="username" v-model="user.name" type="text" placeholder="new username" minlength="4" maxlength="23" pattern="^[a-zA-Z0-9_]{4,23}$" title="4-23 characters, alphanumeric and underscores" />
			<br><br>
			<button type="submit" ref="confirm" class="button">Confirm</button> &nbsp;
			<button type="button" @click="state = AccountState.Init" class="button ghost">Cancel</button>
		</form>
	</div>
	<div class="card" v-else-if="state === AccountState.Exists">
		<span>Name change</span>
		<p>This username is already in use. Please use a different username.</p>
		<div class="options">
			<button type="button" @click="state = AccountState.Username" class="button">Try again</button>
			<button type="button" @click="state = AccountState.Init" class="ghost">Cancel</button>
		</div>
	</div>
	<div class="card" v-else-if="state === AccountState.Changed">
		<span>Password reset</span>
		<p>Your password has successfully been changed.</p>
		<div class="options">
			<button type="button" @click="state = AccountState.Init" class="button">Return</button>
		</div>
	</div>
	<div class="card" v-else-if="state === AccountState.Error">
		<span>Error:</span>
		<pre>{{error}}</pre>
		<div class="options">
			<button type="button" @click="state = AccountState.Init" class="button">Return</button>
		</div>
	</div>
	<div :class="{card: true, legacy: isImported}" v-else>
			<span>{{ acc.name }}</span>
			<ul>
					<li v-for="(char, id) in acc.chars" :key="id">{{ char.name }}</li>
			</ul>
			<div class="options" v-if="state === AccountState.Manage">
				<button type="button" @click="state = AccountState.Username" class="button">change username</button>
				<button type="button" @click="state = AccountState.Password" class="button">change password</button>
				<!--<button type="button" disabled class="button">move characters</button>
				<button type="button" disabled class="button ghost">delete account</button>-->
			</div>
			<div class="options" v-else>
				<button type="button" @click="state = AccountState.Manage" class="button">manage</button>
			</div>
	</div>
</template>

<script lang="ts">
import { Component, Prop, Vue } from "vue-property-decorator"

enum AccountState {
	Init,     // initial state
	Password, // change password
	Changed,  // successfully changed password
	Username, // change username
	Changed2, // name changed
	Exists,   // name already exists
	Error,    // misc error
	Manage,   // show menu
}

@Component({
	data () {
		return { AccountState }
	},
})
export default class GameAccountCard extends Vue {
	@Prop() private name!: string
	@Prop() private acc!: any
	state = AccountState.Init
	error = ""
	isImported = false
	user = {
		name: "",
		password: "",
	}

	async beforeMount () {
		if (Reflect.has(this.acc, "legacyId") && this.acc.legacyId) {
			this.isImported = true
		}
	}

	async pwReset () {
		const button = this.$refs.reset as HTMLButtonElement

		button.disabled = true

		const req = new Request(`${process.env.VUE_APP_API}/vault/evol/account`, {
			method: "PATCH",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
			body: JSON.stringify({
				accountId: this.acc["accountId"],
				password: this.user.password,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.state = AccountState.Error
			this.error = "Couldn't reach the API"
			console.error(err)
			return
		}

		const json = await rawResponse.json()

		button.disabled = false

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		if (Reflect.has(json, "accounts")) {
			this.$store.commit("setGameAccounts", json.accounts)
		} else if (Reflect.has(json, "account")) {
			this.$store.commit("setGameAccount", json.account)
		}

		switch (rawResponse.status) {
		case 200:
			this.state = AccountState.Changed
			return
		case 401:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 429:
			this.state = AccountState.Error
			this.error = "Too many requests"
			return
		case 500:
			this.state = AccountState.Error
			this.error = "Internal server error"
			return
		case 502:
			this.state = AccountState.Error
			this.error = "The API is unreachable"
			return
		default:
			this.state = AccountState.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}

	async nameChange () {
		const button = this.$refs.confirm as HTMLButtonElement

		button.disabled = true

		const req = new Request(`${process.env.VUE_APP_API}/vault/evol/account`, {
			method: "PATCH",
			mode: "cors",
			cache: "no-cache",
			redirect: "follow",
			referrer: "no-referrer",
			headers: {
				"Accept": "application/json",
				"Content-Type": "application/json",
				"X-VAULT-SESSION": this.$store.state.session.sessionKey,
				"X-VAULT-TOKEN": this.$store.state.session.secretKey,
			},
			body: JSON.stringify({
				accountId: this.acc["accountId"],
				username: this.user.name,
			}),
		})

		let rawResponse

		try {
			rawResponse = await fetch(req)
		} catch (err) {
			this.state = AccountState.Error
			this.error = "Couldn't reach the API"
			console.error(err)
			return
		}

		const json = await rawResponse.json()

		button.disabled = false

		if (Reflect.has(json, "session")) {
			this.$store.commit("expiry", json.session.expires)
		}

		if (Reflect.has(json, "accounts")) {
			this.$store.commit("setGameAccounts", json.accounts)
		} else if (Reflect.has(json, "account")) {
			this.$store.commit("setGameAccount", json.account)
		}

		switch (rawResponse.status) {
		case 200:
			this.state = AccountState.Changed2
			return
		case 401:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 409:
			this.state = AccountState.Exists
			return
		case 410:
			this.$store.commit("session", {})
			this.$router.push({name: "login", params: {expired: "true"}})
			return
		case 429:
			this.state = AccountState.Error
			this.error = "Too many requests"
			return
		case 500:
			this.state = AccountState.Error
			this.error = "Internal server error"
			return
		case 502:
			this.state = AccountState.Error
			this.error = "The API is unreachable"
			return
		default:
			this.state = AccountState.Error
			this.error = `Unknown error: ${rawResponse.status}`
			return
		}
	}
}
</script>

<style scoped>
.card {
	background: var(--main-1);
	box-shadow: 0 4px 8px 0 rgba(0,0,0,0.2);
	margin: 0;
	padding: .8rem;
	display: flex;
	flex-direction: column;

	&.legacy {
		background: var(--prime-2);
		position: relative;
		border-color: var(--prime-5);

		& > span {
			padding-top: .5em;
			color: var(--prime-5);
		}
		&::before {
			content: "Legacy account";
			position: absolute;
			background: var(--prime-5);
			color: var(--prime-1);
			font-weight: bold;
			border: solid 1px var(--prime-5);
			border-bottom: 0;
			font-size: 0.8em;
			padding: 0.4ex 1ex 0 1ex;
			top: -1px;
			left: -1px;
			right: -1px;
		}
	}

	& ul {
		padding: .7em;

		& li {
			font-family: monospace;
		}
	}

	& span {
		font-size: 1.2em;
	}

	& button {
		width: 100%;
	}

	& .options {
		margin-top: auto;
	}
}
</style>
